package ru.dbotthepony.mc.otm.config

import ru.dbotthepony.mc.otm.core.math.Decimal

interface EnergyBalanceValues {
	val energyCapacity: Decimal
	val energyThroughput: Decimal
}

interface WorkerBalanceValues : EnergyBalanceValues {
	val workTimeMultiplier: Double
	val energyConsumption: Decimal
	val matterCapacity: Decimal
	val maxExperienceStored: Double
}

interface VerboseEnergyBalanceValues {
	val energyCapacity: Decimal
	val maxEnergyReceive: Decimal
	val maxEnergyExtract: Decimal
}

interface BatteryBalanceValues : VerboseEnergyBalanceValues {
	val initialBatteryLevel: Decimal
}
